﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using HarmonyLib;

using UnityEngine;


namespace AutoFixStationByReciper
{

    [HarmonyPatch(typeof(UIStationWindow))]
    internal class PatchUIStationWindow
    {
        [HarmonyPostfix]
        [HarmonyPatch("_OnInit")]
        public static void PatchOnCreate()
        {
            UIStationWindow stationWindow = UIRoot.instance.uiGame.stationWindow;
            //navi btn

            UIButton btn = Util.MakeSmallTextButton("选择配方", 100);
            if (btn != null)
            {
                btn.gameObject.name = "ZHYB-DSP-MOD-Plugin-ShowReciper-btn";
                RectTransform rect = Util.NormalizeRectD(btn.gameObject);

                rect.SetParent(stationWindow.windowTrans, false);
                rect.anchoredPosition = new Vector3(400f, -60f);

                btn.onClick += OnReciperSelectButtonClick;
                btn.tips.tipTitle = "ShowReciper";
                btn.tips.tipText = "Auto fix Station By Reciper";
                btn.tips.corner = 8;
                btn.tips.offset = new Vector2(0f, 8f);
                btn.gameObject.SetActive(true);
            }
        }

        private static void OnReciperSelectButtonClick(int obj)
        {
            if (UIRecipePicker.isOpened)
            {
                UIRecipePicker.Close();
            }
            else
            {
                UIRecipePicker.Popup(UIRoot.instance.uiGame.stationWindow.windowTrans.anchoredPosition + new Vector2(-300f, -135f),
                OnRecipePickerReturn, ERecipeType.None);
            }
        }

        private struct CountRecipeProto
        {
            public int ItemCount;
            public int ResultCount;

        }

        private static void OnRecipePickerReturn(RecipeProto recipeProto)
        {
            if (recipeProto == null)
                return;
            StationComponent component = AutoFixStationByReciper.factory.transport.stationPool[UIRoot.instance.uiGame.stationWindow.stationId];
            if (component == null)
                return;
            int idx = 0;
            for (idx = 0; idx < component.storage.Length; idx++)
                component.storage[idx].itemId = 0;


            CountRecipeProto countRecipeProto, tmp;

            Dictionary<int, CountRecipeProto> keyValuePairs = new Dictionary<int, CountRecipeProto>();
            for (idx = 0; idx < recipeProto.Items.Count(); idx++)
            {
                int itemId = recipeProto.Items[idx];
                int count = recipeProto.ItemCounts[idx];
                if (keyValuePairs.TryGetValue(itemId, out countRecipeProto))
                {
                    tmp = countRecipeProto;
                    tmp.ItemCount = count;
                    keyValuePairs[itemId] = tmp;
                }
                else
                {
                    tmp.ItemCount = count;
                    tmp.ResultCount = 0;
                    keyValuePairs.Add(itemId, tmp);
                }
            }
            for (idx = 0; idx < recipeProto.Results.Count(); idx++)
            {
                int itemId = recipeProto.Results[idx];
                int count = recipeProto.ResultCounts[idx];
                if (keyValuePairs.TryGetValue(itemId, out countRecipeProto))
                {
                    tmp = countRecipeProto;
                    tmp.ResultCount = count;
                    keyValuePairs[itemId] = tmp;
                }
                else
                {
                    tmp.ItemCount = 0;
                    tmp.ResultCount = count;
                    keyValuePairs.Add(itemId, tmp);
                }
            }
            idx = 0;

            foreach (var kv in keyValuePairs)
            {
                tmp = kv.Value;
                AutoFixStationByReciper.factory.transport.SetStationStorage(
                    component.id, idx++,
                    kv.Key, int.MaxValue,
                    tmp.ItemCount == 0 ? ELogisticStorage.Supply : (tmp.ItemCount > tmp.ResultCount ? ELogisticStorage.Demand : ELogisticStorage.Supply),
                    tmp.ItemCount == 0 ? ELogisticStorage.Supply : (tmp.ItemCount > tmp.ResultCount ? ELogisticStorage.Demand : ELogisticStorage.Supply),
                    GameMain.mainPlayer
                    );

            }


            if (component.isStellar && (component.storage[component.storage.Length - 1].itemId == ItemIds.Warper || component.storage[component.storage.Length - 1].itemId == 0))
            {
                AutoFixStationByReciper.factory.transport.SetStationStorage(
                       component.id, component.storage.Length - 1,
                       ItemIds.Warper, 100,
                       ELogisticStorage.Demand, ELogisticStorage.None,
                       GameMain.mainPlayer);
            }
        }
    }

}
